//
// Created by philipp on 03.04.18.
//

#include <NetworkingLib/Networking.h>
#include "../include/PlatoonProtocolLib/Protocol.h"
#include "../include/PlatoonProtocolLib/FollowerVehicle.h"

int main(int argc, char ** argv)
{
    using namespace platoonProtocol;

    if (argc < 3)
    {
        std::cerr << "Too few arguments!\n";
        return -1;
    }

    networking::Networking net;

    auto vehicleId = static_cast<VehicleId>(atoi(argv[1]));
    std::string broadcastAddress{argv[2]};

    auto follower = FollowerVehicle::create(net, NetworkInfo{vehicleId, broadcastAddress});
    follower->setOnRunningPlatoonCallback([]
                                          { std::cout << "Platoon is running!\n"; });
    follower->setOnLeavingPlatoonCallback([]
                                          { std::cout << "Left platoon!\n"; });
    follower->setOnPlatoonConfigUpdatedCallback(
        [follower]
        {
            auto config = follower->getPlatoonConfig();
            std::cout << "Config Update:\nIPD=" << config.innerPlatoonDistance
                      << "\nPS=" << config.platoonSpeed << "\n";
        });

    auto numVehiclesToRequest = argc - 3;
    for (std::size_t i = 0; i < numVehiclesToRequest; i++)
        follower->addVehicleToRequest(static_cast<VehicleId>(atoi(argv[i + 3])));

    follower->createPlatoon();

    while (1);

    return 0;
}